import UploadSystem from "@/core/components/UploadSystem";
import useNotification from "@/lib/app/hooks/useNotification";
import useRequest from "@/lib/app/hooks/useRequest";
import {
    Box,
    Button,
    DialogActions,
    DialogContent,
    FormHelperText,
    Grid,
    LinearProgress,
    Stack,
    TextField,
    Typography
} from "@mui/material"
import {useFormik} from "formik";
import {useTranslations} from "next-intl";
import {CONFIRM_TRANSPORTATION_ASSISTANCE, GET_TRANSPORTATION_ASSISTANCE_DETAILS} from "@/core/data/apiRoutes";
import {useEffect, useState} from "react";
import * as Yup from "yup";
import CustomAccordion from "@/core/components/CustomAccordion";
import ImageContent from "@/core/components/ImageContent";

const ConfirmContent = ({rowId, mutate, setOpenConfirmDialog, handleSizeChangeClick}) => {
    const t = useTranslations();
    const [selectedImage, setSelectedImage] = useState("");
    const [fileType, setfileType] = useState(null);
    const [fileName, setfileName] = useState(null);
    const [showAddIcon, setShowAddIcon] = useState(true);
    const requestServer = useRequest({auth: true, notification: false})
    const [accordionStates, setAccordionStates] = useState([]);
    const [hasAccordionOpened, setHasAccordionOpened] = useState([]);
    const {update_notification} = useNotification();
    const [hasImageShown, setHasImageShown] = useState(false);
    const [imageLink, setImageLink] = useState(null);
    const [detailsList, setDetailsData] = useState(null);
    const [loading, setLoading] = useState(true);
    const [isSkeleton, setIsSkeleton] = useState(false);

    useEffect(() => {
        requestServer(`${GET_TRANSPORTATION_ASSISTANCE_DETAILS}/${rowId}`, 'get')
            .then((response) => {
                const booleanData = Array.from({length: response.data.data.attachment_files.length}, () => false);
                setAccordionStates(booleanData);
                setHasAccordionOpened(booleanData);
                setDetailsData(response.data)
            })
            .catch(() => {
            }).finally(() => {
            setLoading(false);
        });
    }, []);

    const handleAccordionChange = (index) => {
        const newAccordionStates = accordionStates.map((state, i) => i === index ? !state : false);
        setAccordionStates(newAccordionStates);

        if (!newAccordionStates[index]) {
            handleSizeChangeClick('sm');
            setHasImageShown(false);
            setIsSkeleton(false)
        } else {
            handleSizeChangeClick('xl');
            setHasImageShown(true);
            setImageLink(detailsList.data.attachment_files[index])
            setIsSkeleton(true)
            const newHasAccordionOpened = [...hasAccordionOpened];
            newHasAccordionOpened[index] = true;
            setHasAccordionOpened(newHasAccordionOpened);
        }
    };


    const validationSchema = Yup.object().shape({
        confirm_img: Yup.mixed().notRequired(t("ConfirmDialog.approved_amount_error"))
            .test('fileSize', `${t("TransportationAssistance.upload_file_unit")}`, (value) => {
                if (!value) return true
                return value.size <= 2 * 1024 * 1024;
            })
            .test('fileType', `${t("TransportationAssistance.upload_file_format")}`, (value) => {
                if (!value) return true
                const allowedTypes = ['image/jpg', 'image/jpeg', 'image/png', 'application/pdf'];
                return allowedTypes.includes(value.type);
            })
    })

    const formik = useFormik({
        initialValues: {
            description: "",
            confirm_img: null
        }, validationSchema,
        onSubmit: (values, {setSubmitting}) => {
            const formData = new FormData();
            if (values.description != "") formData.append("expert_description", values.description);
            if (values.confirm_img != null) formData.append("attachment", values.confirm_img);

            requestServer(`${CONFIRM_TRANSPORTATION_ASSISTANCE}/${rowId}`, 'post', {
                data: formData,
            }).then((response) => {
                setOpenConfirmDialog(false)
                mutate()
                update_notification()
            }).catch(() => {
            }).finally(() => {
                setSubmitting(false);
            });
        },
    });

    const handleDescriptionChange = (event) => {
        formik.setFieldValue("description", event.target.value)
    };

    const handleUploadChange = (event) => {
        const uploadedFile = event.target?.files?.[0];
        if (uploadedFile) {
            const fileType = event.target?.files?.[0].type;
            const fileName = event.target?.files?.[0].name;
            setSelectedImage(URL.createObjectURL(uploadedFile));
            setfileType(fileType);
            setfileName(fileName);
            formik.setFieldValue("confirm_img", uploadedFile).then(() => {
                formik.setFieldTouched("confirm_img", true);
            })
            setShowAddIcon(false);
        }
    };

    const renderCustomAccordions = () => {
        if (detailsList && detailsList.data && detailsList.data.attachment_files) {
            return detailsList.data.attachment_files.map((file, index) => (
                <CustomAccordion
                    key={index}
                    title={`${file.title}`}
                    hasOpened={accordionStates[index]}
                    hasAccordionOpened={hasAccordionOpened[index]}
                    handleAccordionChange={() => handleAccordionChange(index)}
                    accordionIndex={index}
                    downloadFile={file.attachment}
                />
            ));
        }
        return null;
    };
    const numberShowBox = () => {
        return (
            <>
                <Box sx={{border: '1px solid #ccc', p: 2, mb: 2, borderRadius: '8px'}}>
                    <Typography sx={{
                        color: "primary.main",
                        fontWeight: 500
                    }}>{t("ConfirmDialog.proposed_amount")} {t("sidebar.machinery-expert")}</Typography>
                    <Typography pt={1}>
                        {isNaN((detailsList?.data?.proposed_amount) / 10)
                            ? ""
                            : ((detailsList?.data?.proposed_amount) / 10).toLocaleString()}{" "}
                        {t("ConfirmDialog.unit")}
                    </Typography>
                </Box>
                <Box sx={{border: '1px solid #ccc', p: 2, mb: 2, borderRadius: '8px'}}>
                    <Typography sx={{
                        color: "primary.main",
                        fontWeight: 500
                    }}>{t("ConfirmDialog.approved_amount")} {t("secondary.passenger-boss")}</Typography>
                    <Typography pt={1}>
                        {isNaN((detailsList?.data?.approved_amount) / 10)
                            ? ""
                            : ((detailsList?.data?.approved_amount) / 10).toLocaleString()}{" "}
                        {t("ConfirmDialog.unit")}
                    </Typography>
                </Box>
            </>
        );
    };
    return (
        <>
            <DialogContent>
                <Grid container spacing={2}>
                    <Grid item xs={hasImageShown ? 6 : 12}>
                        {loading ? <LinearProgress/> :
                            <>
                                {numberShowBox()}
                                {renderCustomAccordions()}
                            </>
                        }
                        <Stack spacing={2}>
                            <Stack>
                                <TextField
                                    name="description"
                                    multiline
                                    rows={8}
                                    label={<>
                                        <span>{t("ConfirmDialog.description")}</span><small>{t("ConfirmDialog.optional")}</small></>}
                                    value={formik.values.description}
                                    onChange={handleDescriptionChange}
                                    fullWidth
                                    variant="outlined"
                                    sx={{mt: 1}}
                                />
                            </Stack>
                            <Stack>
                                <Typography>{t("UploadSystem.upload_file")}{t("UploadSystem.optional")}</Typography>
                                <UploadSystem
                                    selectedImage={selectedImage}
                                    handleUploadChange={handleUploadChange}
                                    setselectedImage={setSelectedImage}
                                    setFieldValue={formik.setFieldValue}
                                    fieldname="confirm_img"
                                    fileType={fileType}
                                    fileName={fileName}
                                    imageAlt={t("app_name")}
                                    imageSize={[250, 150]}
                                    setShowAddIcon={setShowAddIcon}
                                    showAddIcon={showAddIcon}
                                    onBlur={() => formik.handleBlur("confirm_img")}
                                    error={
                                        formik.touched.confirm_img &&
                                        Boolean(formik.errors.confirm_img)
                                    }
                                />
                                <FormHelperText
                                    error={Boolean(formik.errors.confirm_img)}
                                >
                                    {formik.touched.confirm_img && formik.errors.confirm_img}
                                </FormHelperText>
                            </Stack>
                        </Stack>
                    </Grid>
                    <Grid item xs={6}>
                        <Stack sx={{
                            display: hasImageShown ? 'flex' : 'none',
                            alignItems: 'center',
                            gap: 0.5,
                            justifyContent: 'center'
                        }}>
                            <ImageContent imageLink={imageLink} isSkeleton={isSkeleton} setIsSkeleton={setIsSkeleton}/>
                        </Stack>
                    </Grid>
                </Grid>
            </DialogContent>
            <DialogActions>
                <Button onClick={() => setOpenConfirmDialog(false)} variant="outlined" color="secondary"
                        disabled={formik.isSubmitting} autoFocus>
                    {t("ConfirmDialog.button-cancel")}
                </Button>
                <Button onClick={formik.handleSubmit} variant="contained" color="primary"
                        disabled={formik.isSubmitting || !formik.isValid ||
                            hasAccordionOpened.some((opened) => !opened)}
                >
                    {t("ConfirmDialog.button-confirm")}
                </Button>
            </DialogActions>
        </>
    )

}
export default ConfirmContent